'Region Description
'
' Name:				Backup_VMWare
' Author:			Stefan Mrosek (berarbeitete Version von Saxa
'					siehe http://www.vmware.com/community/thread.jspa?threadID=53045&tstart=1)
' Version:			0.9.4 Beta 2
' Description:		Das Script Stoppt die per Parameter bergebene virtual Maschine eines VMWare-Serves, 
'					erstellt eine Kopie der vm, Startet die vm wieder und komprimiert anschlieend 
'					die Kopie der vm mit 7Zip. Ergebnisse der Prozedur werden per Mail versendet und ins Eventlog
'					eingetragen
'
'Vorraussetzungen:	Server:	VMWare Server ab 1.0
'							Windows 2003 Server 
'					Client: (Scriptausfhrender Rechner)
'							ab Windows XPSP2 (getestet auf Windows XP SP2)
'							VMCom-API (wird mit VMWare Console installiert, auch einzeln downloadbar)
'							installiertes 7Zip
' 
' Syntax:			backup_vm.vbs
' 						Ohne Parameterbergabe werden die notwendigen Daten fr das BAckup einer VM interaktiv abgefragt, die Serverdaten mssen 
'						im Script konfiguriert werden
'					backup_vm.vbs -all|-vm:<lokaler Pfad zur VMX-Datei> [-srv:<servername>] [-prt:<Portnummer>] [-usr:<Benutzername>] 
'										[-pwd:<Passwort>] [-dst:<UNC Zielpfad>] [-tmp:<TEMP-Pfad>] [-int]
'
'					Nicht bergebene Parameter werden der Konfig im Script entnommen
'
'					Beispiele:
'					Backup_VM.vbs -all 		Sichert alle VMs des im Konfigteil des Scripts angegebenen Servers
'
'					Backup_VM.vbs -all -srv:192.168.1.1 -usr:domain\user -pwd:password -tmp:\\server\freigabe\pfad -dst: \\server2\freigabe\pfad -int
'											Sichert alle VMs des Servers 192.168.1.1 mit den bergebenen Anmeldedaten fr den Server. Die temporren Kopien der VMs 
'											werden in \\server\freigabe\pfad und die Zipfiles in \\server2\freigabe\pfad abgelegt. Der Status wird interaktiv angezeigt.
' 
'					Backup_VM.vbs -vm:d:\vmguest1\guest1.vmx -srv:192.168.1.1 -usr:domain\user -pwd:password -tmp:\\server\freigabe\pfad -dst: \\server2\freigabe\pfad
'											Sichert die VM "d:\vmguest1\guest1.vmx" vom angegebenen Server. Es erfolgen keine Bildschirmausgaben. Dieser Aufruf ist "Batch-geeignet"
'
'					Backup_VM.vbs 			Die zu sichernde VM und der Zielordner werden interaktiv abgefragt.
' EndRegion

'Region Changelog
	' 13.06.07			V0.9.4
	'					Check, ob VM bei Herunterfahren hngt, hartes shutdown nach Timeout
	'					Backup All VMs eines Servers 
	'					Einfhrung der Klasse VM_Guest um Backup aller VMs zu hndeln
	'					Neue flexiblere Parameterbergabe (siehe Syntax)
	'					Errorhandling berarbeitet
	'					Diverse Bugfixes
		
	' 12.12.06			V0.9.3
	'					Textnachrichten aus Quelltext in Konfigteil verschoben fr bessere bersicht
	'					Nicht laufende VMs werden gleich komprimiert, und nicht erst zum Backupdrive kopiert
	' 11.12.06  		V0.9.2 
	'					Klasse iestatus integriert
    '					Im Interaktiven Mode wird der aktuelle Status in einem IE-Fenster ausgegeben
	'					RemoteBackup hinzugefgt
	'					Vor Backup nun Check ob noch gengend Plattenplatz auf Backupdrive ist
	'					diverse kleine nderungen
	' 08.12.06  		Bugfix: Konfig AlertMail wurde nicht ausgewertet 
    '					und Mails immer verschickt 
	' 07.12.06			V0.9.1
	'					Schreiben von Logfiles integriert
	'					Globales Log fr Start-Stop und Errors
	'					Log je VM-Sicherung mit zustzlichen Statusmeldungen
	'					Versand des Sicherungslog mit Abschlumail
	'					Loglevel fr Eventlog und Globales Logfile konfigurierbar
	
	' 06.12.06			Funktion zum Lschen des tempFolders hinzugefgt mit Benachrichtigung bei
	'					erfloglosem Lschen
	'					Fehlerhafte Dateigrenberechnung korrigiert
	'					Bug behoben: Lschen der Kopie von suspended VMs nicht mglich
	
	' 05.12.06			Starte gleich mit V0.9 ;) Saxa hat schlielich gute Vorarbeit geleistet

'EndRegion

'Region Konfiguration
debugging = False			'nur fr Entwicklungszwecke, default = false
vmfile = "F:\VM-Pfad\VM.vmx"		'Voreinstellung des Pfades fr Interaktiven Modus relativ zum VMWare Server
												'Unter diesem Pfad ist die VM auf dem Server registriert
												'Wird bentigt um sich zur VM zu connecten

'	bkpath -> 			Zielpfad, hier werden temporre Dateien abgelegt und das Zip-Archiv erzeugt
' 						Mglich ist ein lokales Laufwerk oder ein UNC-Pfad. Berechtigungen prfen!
 
bkpath = "\\Servre\Freigabe\Pfad\"	'Voreinstellung fr Zielpfad frs Backup relativ zum Host der das Script ausfhrt
LogPath = ""						'Voreinstellung des Pfades fr Logfiles, standard = bkpath
tmpfolder=""

remote_host = "172.24.128.8"			'IP-Adresse des VMWare Servers
remote_port = "902"					'902 ist Standard
remote_user = "Domne\USer"				'Nutzer auf dem VMWareServer, der die VM starten darf
remote_pass = "Passwort"				'Passwort

' Konfiguration fr die EMailbenachrichtigung, notwendig wenn AlertMail = True
adminmail = "user@mail.lan"		'Zieladresse.
adminmailcc = ""						'Zieladresse Kopie
mailfrom = "vmware_backup@mail.lan"		'Absenderadresse
smtp = "smtpserver.mail.lan"				'SMTP-Server
header = "VMBackup"	 


backup_all_vms = False  	'wenn true werden alle VMs des Konfigurierten Servers gesichert	

use_suspend = False		'Wenn auf True gesetzt, wird eine Laufende VM vor dem Backup in den Suspend-Mode versetzt
						'Bei False wird versucht das Wirts-Betriebssystem herunterzufahren und die VM abzuschalten
						'In beiden Fllen wird die VM nach dem Backup wieder gestartet
						'ACHTUNG 
						'Mit Suspend gesicherte VMs knnen nur auf einem VMWare Server mit identischer Hardware (CPU/RAM)
						'zurckgesichert und wieder in Betrieb genommen werden
						
use_hart_suspend_if_no_VMTools = False
						'Wenn die VMWare-Tools des Gastbetriebssystems nicht connectet werden knnen um die VM
						'Herunterzufahren oder zu suspendieren den Hart-Suspend-Mode nutzen?
						'In diesem Mode werden keine Poweroff oder Suspend-Scripte im Gastbetriebssystem mehr ausgefhrt!
						'ACHTUNG Ein Hard-Suspend bei Domaincontrollern oder SQL-Servern kann zu Problemen fhren
						'Nur be Systemen verwenden, wo auch ein Drcken des Powerschalters keine Schden verursacht ;-)
						'Mit Suspend gesicherte VMs knnen nur auf einem VMWare Server mit identischer Hardware (CPU/RAM)
						'zurckgesichert und wieder in Betrieb genommen werden

backup_remote_host = True			'True Sicherung eines Remote-Servers, False lokales Sichern
									'Bei einer Remotesicherung mu der UNC-Pfad zur zu sichernden VM 
									'relativ zum Scriptausfhrenden Rechner in vmpath angegeben werden
 
compress = True						'Backupdaten komprimieren?
' Wahl der Komprimierung
seven_zip = True					'7Zip nutzen? 
seven_zip_switch = ""				'Parameter fr 7Zip

winzip = False						'Winzip nutzen - noch nicht implementiert!!

'Alte Backuparchive automatisch lschen
CleanUpBackupFiles = True			'Should the script delete old backup files for this VM upon sucessfull backup
									'The following are Only needed if the above value is true
NumberBackupsToKeep = 3				'Maximum number of backups per VM to keep.  Oldest backups above this number are deleted
MinFileSize = 1						'Minimale Dateigre (MB) frs lschen, kleinere Files werden stehen gelassen

'   Benachrichtigungen
LogPath = ""						'Pfad fr die Logfiles, wenn keine Angabe wird automatisch der BAckupfad bernommen
if LogPath = "" then LogPath = bkpath
AlertMail = True
AlertEvent = True
AlertEventLevel = 1					' 0 Erfolg
									' 1 Erfolg + Error
									' 2 Erfolg, Error und Warning
									' 4 Alles incl Informationen
Alertbox = True						'Messageboxen werden im Automodus nicht angezeigt - Config gilt nur fr Interaktiven Mode
 
'EndRegion

'Region Timeouts
VMStopMaxHungChecks = 10			'If the VM didn't stop how many times should we check if it's hung
VMStopHungSeconds = 60				'Seconds VM is unresponsive to consider it hung
VMStopMaxTries = 10				'Number of attempts to stop the VM 
VMStopTryInterval = 60				'Seconds between attempts to stop the VM
'EndRegion

'Region Definition der Infonachrichten
MSG_Inputbox_VMFile = "Bitte geben Sie den vollen Pfad zum .vmx file der zu sichernden VM an:" & VbCrLf & VbCrLf & "(relativ zum VMWare-Server, Pfad = im Server registrierter Pfad der VM)"
MSG_Inputbox_Zipfile = "Jetzt geben Sie bitte den vollen Pfad zum zu erzeugenden ZIP-File an:"

MSG_ERR_zu_viele_Parameter_long = "Es wurden falsche Parameter beim Aufruf bergeben. " & VbCrLf & "Syntax: Backup_VMWare.vbs VMX-File [Ziel]"
MSG_ERR_zu_viele_Parameter_short = "Falsche Parameter beim Aufruf"
MSG_ERR_zu_wenig_Plattenplatz_long = "Der Platz auf dem Backupdrive reicht nicht fr das Kopieren der VM. Backup abgebrochen"
MSG_ERR_zu_wenig_Plattenplatz_short = "Unzureichender Platz auf dem Backupdrive."
MSG_ERR_zu_wenig_Plattenplatz_zum_komprimieren_short = "Der Platz auf dem Backupdrive reicht nicht fr das Komprimieren der VM. Backup abgebrochen"
MSG_ERR_zu_wenig_Plattenplatz_zum_komprimieren_long = "Unzureichender Platz auf dem Backupdrive."
MSG_ERR_7Zip_not_found_long = "Das VMWare Backupscript konnte das Programm 7Zip auf dem server nicht finden." & VbCrLf & "Bitte besuchen Sie 7zip.org und installieren Sie das Tool um die Backupdaten zu komprimieren."
MSG_ERR_7Zip_not_found_short = "7Zip nicht installiert"
MSG_ERR_Compress_but_no_Zip_long = "In der Konfiguration des VMWare Backupscripts wurde die Komprimierung aktiviert, aber kein Packprogramm konfiguriert."
MSG_ERR_Compress_but_no_Zip_short = "Fehlerhafte Konfiguration der Komprimierung"

MSG_ERR_remote_host_missing_short = "Remotehost nicht definiert"
MSG_ERR_remote_host_missing_long = "Remotehost nicht definiert"
MSG_ERR_remote_port_missing_short = "Remote-Port nicht definiert"
MSG_ERR_remote_port_missing_long = "Remote-Port nicht definiert"
MSG_ERR_remote_pass_missing_short = "Remote-Passwort nicht definiert"
MSG_ERR_remote_pass_missing_long = "Remote-Passwort nicht definiert"
MSG_ERR_remote_user_missing_short = "Remoteuser nicht definiert"
MSG_ERR_remote_user_missing_long = "Remoteuser nicht definiert"

MSG_ERR_VM_File_not_found_short = "Zu sichernde VM nicht gefunden."
MSG_ERR_VM_File_not_found_long = "Das zu sichernde VMX-File konnte nicht gefunden werden."


MSG_ERR_ServerConnect_long = "Das VMWare Backupscript konnte keine Verbindung zum VMWare Server herstellen." & VbCrLf & "Bitte berprfen Sie, ob die VMWare Dienste laufen und ob die VMCom-API installiert ist." 
MSG_ERR_ServerConnect_short = "Konnte keine Verbindung zum VMWare Server herstellen."
MSG_SUC_ServerConnect = "Serverconnect erfolgreich"

MSG_ERR_VMConnect_long = "Das VMWare Backupscript konnte keine Verbindung zur virtuellen Maschine herstellen." & VbCrLf & "Bitte berprfen Sie, ob der Pfad zur VM korrekt und die VM auf dem Server registriert ist. " 
MSG_ERR_VMConnect_short = "konnte keine Verbindung zur VM herstellen."
MSG_SUC_VMConnect = "VMconnect erfolgreich"

MSG_INF_VMStatus_Running = "VMStatus ist Powered"
MSG_INF_VMStatus_Off = "VMStatus ist Off."
MSG_INF_VMStatus_Suspended = "VMStatus ist Suspended"
MSG_ERR_VMStatus_unknown_long = "Das VMWare Backupscript konnte den Status der VM nicht ermitteln." & VbCrLf & "Korrekte Zustnde sind nur Running, Stopped und Suspended."
MSG_ERR_VMStatus_unknown_short = "Konnte den Status der VM nicht ermitteln."

MSG_ERR_VMToolsConnect_long = "Das VMWare Backupscript konnte die VMWare Tools der VM nicht kontaktieren." & VbCrLf & "Ein Herunterfahren der VM ist nicht mglich." & VbCrLf & "Bitte Fahren Sie die VM manuell herunter und sichern Sie dann."
MSG_ERR_VMToolsConnect_short = "VMWare Tools reagieren nicht. Backup abgebrochen"
MSG_ERR_VMToolsConnect_Suspend_long = "Das VMWare Backupscript konnte die VMWare Tools der VM nicht kontaktieren." & VbCrLf & "Ein Hart-Suspend der VM wird fr das Backup versucht."
MSG_ERR_VMToolsConnect_Suspend_short = "VMWare Tools reagieren nicht. Fahre mit Hart-Suspend fort."
MSG_SUC_VMToolsConnect = "VMWareTools erfolgreich connected"

MSG_INF_Try_Shutdown = "Versuche Shutdown des Gastsystems."
MSG_ERR_Shutdown_long = "Das VMWare Backupscript konnte die  VM nicht in einer angemessenen Zeit herunterfahren." & VbCrLf & "berprfen Sie den Status der VM."
MSG_ERR_Shutdown_short = "Timeout beim Herunterfahren. Backup abgebrochen"
MSG_SUC_Shutdown = "Gastsystem erfolgreich heruntergefahren."

MSG_INF_Try_Suspend = "Versuche Suspend des Gastsystems."
MSG_ERR_Suspend_long = "Das VMWare Backupscript konnte die  VM nicht in einer angemessenen Zeit Susspendieren." & VbCrLf & "berprfen Sie den Status der VM."
MSG_ERR_Suspend_short = "Timeout beim Suspend. Backup abgebrochen"
MSG_SUC_Suspend = "Suspend erfolgreich."

MSG_INF_Try_HartSuspend = "Versuche Hart-Suspend des Gastsystems."
MSG_ERR_HartSuspend_long = "Das VMWare Backupscript konnte die  VM nicht in einer angemessenen Zeit Susspendieren." & VbCrLf & "berprfen Sie den Status der VM."
MSG_ERR_HartSuspend_short = "Timeout beim Hart-Suspend. Backup abgebrochen"
MSG_SUC_HartSuspend = "Hart-Suspend erfolgreich."

MSG_ERR_VM_Hung_short = "VM Hngt beim Herunterfahren - Versuche Hard-Shutdown."
MSG_ERR_VM_Hung_long = "Das VMWare Backupscript konnte die  vm nicht In einer angemessenen Zeit herunterfahren. Die VM Hngt." & VbCrLf & "Es wird ein Hard-Shutdown versucht." 
MSG_INF_Shutdown_hard_short = "Start des Hard-Shutdown"
MSG_INF_Shutdown_hard_long = "Start des Hard-Shutdown"
MSG_ERR_Shutdown_hard_short = "Hard-Shutdown erfolglos!"
MSG_ERR_Shutdown_hard_long= "Hard-Shutdown erfolglos! Script abgebrochen!"

MSG_INF_Start_Copy = "Starte Kopierprozess."
SMG_INF_SkipCopy = "VM war offline. berspringe Kopiervorgang."
MSG_SUC_Copy = "Kopierprozess beendet."

MSG_INF_Try_VMStart = "Versuche Gastsystem wieder zu starten."
MSG_ERR_VMStart_long = "Das VMWare Backupscript konnte die VM nicht starten oder die VMWare Tools konnten nicht starten." & VbCrLf & "berprfen Sie den Status der VM."
MSG_ERR_VMStart_short = "Gastsystem nicht erfolgreich gestartet."
MSG_SUC_VMStart = "Gastsystem erfolgreich gestartet."

MSG_INF_Start_Compress = "Starte das Komprimieren."
MSG_ERR_Compress_long = "Das VMWare Backupscript konnte kein Zip-Archiv erstellen." & VbCrLf & "Prfen Sie ob in " & tmpfolder & " gengend Speichrplatz vorhanden ist und starten Sie das Backup erneut."
MSG_ERR_Compress_short = "Komprimieren der VM fehlgeschlagen"
MSG_SUC_Compress = "Komprimierung erfolgreich"

MSG_INF_Start_Delete_Tmp = "Lsche Tempfiles"
MSG_ERR_Delete_Tmp_long = "Beim Lschen der temporren Backupdateien der VM ist ein Fehler aufgetreten." & VbCrLf & VbCrLf & "Das Verzeichniss konnte nicht korrekt gelscht werden."
MSG_ERR_Delete_Tmp_short = "Fehler beim Lschen der temporren Kopie der VM."
MSG_SUC_Delete_Tmp = "Die temporre Kopie der VM wurde gelscht."
MSG_skip_Delete_Tmp = "Da die VM nicht kopiert wurde sind keine Tempfiles zu lschen."

MSG_INF_Delete_Backups = "Lsche alte Backupfiles."
MSG_SUC_Delete_Backups = "Lschen der alten Backupsfiles erfolgreich."

MSG_Minuten = " Minuten"
MSG_Gigabyte = " GB"
MSG_Succes_1 = "Die virtuelle Maschine " 'VMName
MSG_Succes_2 = " wurde gesichert."
MSG_Succes_Zip_1 = "Das Backup wurde als " 'Zipfilename
MSG_Succes_Zip_2 = " gespeichert."
MSG_Succes_Ziptime_1 = "Die Kompression dauerte " 'Zeit
MSG_Succes_No_Zip = "Das Backup wurde nicht komprimiert."
MSG_Success_Copytime = "Das Kopieren dauerte "
MSG_Success_VMShutdownTime = "Das Herunterfahren dauerte "
MSG_Success_VMStartTime = "Das Starten dauerte "
MSG_Success_VMOfflineTime = "Die Ausfallzeit der VM betrug "
MSG_Success_GesamtTime = "Die Gesamtdauer betrug "
MSG_Success_ZipSize = "Die Gre der Archivdatei betrgt "
MSG_Success_VMSize = "Die Gre der VM betrgt "
MSG_Success_FreeSpace = "Der freie Plattenplatz auf dem Backuplaufwerk betrgt: "
MSG_Success_StartTime = "Startzeit: "
MSG_Success_EndTime = "Endzeit: "
MSG_Backup_Success = "Backup erfolgreich beendet."
MSG_Backup_Warning = "Backup mit Warnungen beendet."
MSG_Backup_Error = "Backup mit Fehlern beendet."

'EndRegion

' ### Konfiguration Ende - Ab hier nichts mehr ndern, es sei denn Du weist was du da tust ;-)  ###

'Region Global Settings
'On Error Resume Next
Set wshShell = CreateObject("WScript.Shell")
Set fso = CreateObject("Scripting.FileSystemObject")
Set cp = CreateObject("VmCOM.VmConnectParams")
Set thevm = CreateObject("VmCOM.VmCtl")
Set server = CreateObject("VmCOM.VmServerCtl")
Set wshNet = CreateObject("WScript.Network")

Const OneMB = 1048576
Const OneGB = 1073741824
Const OneSecond = 1000

Const vmExecutionState_Off = 2
Const vmExecutionState_On = 1
Const vmExecutionState_Stuck = 4
Const vmExecutionState_Suspended = 3
Const vmExecutionState_Unknown = 5

Const vmPowerOpMode_Hard = 1
Const vmPowerOpMode_Soft = 2
Const vmPowerOpMode_TrySoft = 3

Const Alerttype_success = 0
Const Alerttype_Error = 1
Const Alerttype_warning = 2
Const Alerttype_information = 4

globalerrorflag = 0
globalWarningFlag = 0
'EndRegion

'Region Klasse VM_Guest
Class VM_Guest	 
	Public ZIPFile
	Public ZipFileSize
	Public VMSize
	Public vmparent
	Public vmfolder
	Public vm
	Public LogfileVM
	Public tmpfolder
	Public vm_status
	Public Pending_Operation
	Public ToolsLastActive
	Public vm_status_before_backup
	
	Public vmtools_running
	Public vmfile
	Public VM_Copy
	Public checkpoint_begin
	Public checkpoint_startshutdown
	Public checkpoint_startcopy
	Public checkpoint_startvm
	Public checkpoint_started
	Public checkpoint_startzip
	Public checkpoint_zipped
	Public time_shutdown
	Public time_copy
	Public time_start
	Public time_zip
	Public time_off
	Public time_sum
	
	Public connected
	Public ErrorFlag
	Public WarningFlag
	Dim thevm
	
	Dim m_Copyright

	Public Sub Connect
		For tries_vm = 1 To 10
			thevm.Connect cp, vmfile
			If Err.number = 0 Then
				connected = True
				vm_status_before_backup = thevm.ExecutionState
				vm_status = vm_status_before_backup
				If thevm.Heartbeat > 0 Then 
					vmtools_running = True
	
				Else
					vmtools_running = False
				End If 
				Exit For
			End If
			WScript.Sleep 1000
			Err.clear
		Next

	End Sub
	
	Public Sub Disconnect
		Set thevm = Nothing

	End Sub

	
	Sub Copy
		checkpoint_startcopy = Now
		if debugging = true then WScript.Echo "TMP: " & tmpfolder
		if debugging = true then WScript.Echo "VM: " & vmfolder
		copyVM = fso.CopyFolder(vmfolder,tmpfolder)
		VM_Copy = True
	End Sub
	
	Sub Zip
		

	End Sub
	
	Sub Start
		checkpoint_startvm = Now
		geton = thevm.start(2)
		'	a bisserl Warten bis die VM 300s lief
		For tries_on = 1 To 20
			hbs = thevm.Heartbeat
			If hbs > 300 Then
				vm_status = vmExecutionState_On
				checkpoint_started = Now
				Exit For
			End If
			WScript.Sleep 30 * 1000
			hbs = 0
		Next
		
	End Sub

	
	Sub Suspend
		getoff = thevm.suspend(2)
		For tries_off = 1 To 10
			vm_status = thevm.ExecutionState
			If vm_status = 3 Then
				is_suspended = True
				Exit For
			End If
			WScript.Sleep 60 * 1000
		Next
	End Sub


	Sub Shutdown(PowerOpMode)
		'If debugging = True	then WScript.Echo PowerOpMode
		On Error Resume Next
		getoff = thevm.stop(PowerOpMode)
				
		For tries_off = 1 To 10
			vm_status = thevm.ExecutionState
			If vm_status = vmExecutionState_Off Then
				Exit For
			ElseIf 	vm_status = vmExecutionState_Stuck Then

			End If
			WScript.Sleep VMStopTryInterval * OneSecond
			'vm_status = 0
		Next
	End Sub

	Sub Shutdown_if_Hung
		
		For Check_If_Hung = 1 To VMStopMaxHungChecks
			'This will tell us how long the vm has been unresponsive
			ToolsLastActive = thevm.ToolsLastActive	
			If ToolsLastActive < VMStopHungSeconds Then
				WScript.Sleep ( 1 + VMStopHungSeconds - ToolsLastActive) * OneSecond 
			Else 
				'At this point we can assume the vm is hung and try a hard shutdown
				On Error Resume Next 
				If thevm.ExecutionState <> vmExecutionState_Off Then
					getoff = thevm.stop(vmPowerOpMode_Hard)	'this method has a built in 4 min timeout		
					For tries_off = 1 To VMStopMaxTries
						vm_status = thevm.ExecutionState
						If vm_status = vmExecutionState_Off Then
							Exit For
						End If
						WScript.Sleep VMStopTryInterval * OneSecond 
					Next
				End If
			End If
		Next

	End Sub

	
	Sub get_vm_status
		
		If connected = False Then 
			Exit Sub
		End If

		vm_status = thevm.ExecutionState

	
	End Sub
	
	
	Sub Class_Initialize
		m_Copyright = "<p>IEStatus by <a href='http://www.admins-tipps.de' target='_blank'>www.Admins-Tipps.de</a></p>"
   		connected_m = False
		vmtools_running = False
		ErrorFlag = 0
		WarningFlag = 0
		Set thevm = CreateObject("VmCOM.VmCtl")
 	End Sub
	
	Sub Class_Terminate
		Set thevm = Nothing
	End Sub
End Class
'EndRegion

'Region Klasse IEStatus fr Statusanzeigen im Interaktiven Mode
Class iestatus	 
Dim objExplorer

Dim m_Status
Dim m_Titel
Dim m_Copyright

	Public Property Get Titel
		Text = m_Titel
	End Property
	
	Public Property Let Titel(newTitel)
		m_Titel = newTitel
		'Validation
	End Property
	
	Public Property Get Status
		Text = m_Status
	End Property
	
	Public Property Let Status(newstatus)
		m_Status = newstatus
		'Validation
	End Property
	
	Public Sub Show	
		On Error Resume Next 
 		objExplorer.Document.Body.InnerHTML = "<h1>" & m_Titel & "</h1>" & m_Status & m_Copyright

	End Sub
	Public Sub Update (updatetxt)
 		m_Status = m_Status & updatetxt & "<br>"
		On Error Resume Next
		objExplorer.Document.Body.InnerHTML = "<h1>" & m_Titel & "</h1>" & m_Status & m_Copyright
		

	End Sub

	Public Sub Create
		On Error Resume Next
		objExplorer.Visible = 1
		objExplorer.Document.Body.InnerHTML = "<h1>" & m_Titel & "</h1>"
	End Sub
	Public Sub delete
		On Error Resume Next
		objExplorer.Quit
	End Sub
	
	Sub Class_Initialize
		On Error Resume Next
		m_Copyright = "<p>IEStatus by <a href='http://www.admins-tipps.de' target='_blank'>www.Admins-Tipps.de</a></p>"
		Set objExplorer = WScript.CreateObject("InternetExplorer.Application")
		objExplorer.Navigate "about:blank"   
		objExplorer.ToolBar = 0
		objExplorer.StatusBar = 0
		objExplorer.Width=600
		objExplorer.Height = 400 
		objExplorer.Left = 0
		objExplorer.Top = 1
		objExplorer.MenuBar = vbFalse
		Do While (objExplorer.Busy)
			WScript.Sleep 200
		Loop    
 	End Sub
	
	Sub Class_Terminate
		On Error Resume Next
		objExplorer.Quit
	End Sub
End Class
'EndRegion

'Region Funktionen
	
Public Function DelTreeFSO(ByVal Path ) 
' Lscht mithilfe des FileSystemObject einen 
' Verzeichnisbaum (sofern mglich). 
' Kann der Baum nicht komplett gelscht werden, wird als 
' Funktionsrckgabewert FALSE verwendet. 
' Hinweis: Die Dateien werden direkt gelscht, nicht 
' lediglich in den Papierkorb verschoben! 
  On Error Resume Next 
  ' FileSystemObject instanzieren 
  Set fso = CreateObject("Scripting.FileSystemObject") 
  ' Konnte das Objekt instanziert werden? 
  If Err.Number <> 0 Then 
	DelTreeFSO = False
 	Exit Function 
  End If 
  ' Die DeleteFolder-Methode des Objekts aufrufen 
  fso.DeleteFolder Path, vbTrue
  ' Trat beim Lschen ein Fehler auf? 
  If Err.Number <> 0 Then 
	DelTreeFSO = False
 	Exit Function 
  End If 
  ' Fehlerfreie Abarbeitung => Rckgabewert TRUE 
  DelTreeFSO = True 
End Function

Sub Delete_Old_Backup_Files (ByVal VMName, ByVal BackupFolder)
	'*******************************************************************************************
	'Deletes older backup files to conserve disk space.
	'*******************************************************************************************
	On Error Resume Next
	Set fso = CreateObject("scripting.filesystemobject") 
	Set Folder = fso.getfolder(BackupFolder) 
	Set Files = Folder.Files 
	Dim NFileArray ()
	Dim MFileArray ()
	
	'Initialize values now that we can
	RealFileCount = Folder.Files.Count
	ReDim NFileArray (RealFilecount)
	ReDim MFileArray (RealFileCount)
	
	'Fetch the list of files
	MyFileCount = 0
	For Each file In Files 
	' Only files matching the VM identifier count
	If StrComp (Left(file.name, (Len(VMName)+1)), VMName & "-",1) = 0 Then
		'Only files bigger than "x" MB in size count
		If file.size >= MinFileSize * (1024 * 1024) Then
		MyFileCount = MyFileCount + 1 
		NFileArray(MyFileCount) = file
		MFileArray(MyFileCount) = file.DateLastModified 
		End If
	End If
	Next
	
	'No sense doing anything else if less files then max allowed
	If MyFileCount > NumberBackupsToKeep Then 
	'Sort by modified date
	For i = 1 To MyFileCount 
		For j = (i + 1) To MyFileCount 
		If MFileArray(i) < MFileArray(j) Then 
			NBuffer = NFileArray(j) 
			MBuffer = MFileArray(j) 
			NFileArray(j) = NFileArray(i) 
			MFileArray(j) = MFileArray(i) 
			NFileArray(i) = NBuffer 
			MFileArray(i) = MBuffer 
		End If 
		Next 
	Next 
	'Delete part
	For n = NumberBackupsToKeep + 1 To MyFileCount 'Array position zero is blank
		Set Deletefile = fso.getfile(NFileArray(n))
		Deletefile.delete True 
	Next 
	End If
 
End Sub

Function iso_date(ByVal dt, ByVal dttype, ByVal NoSpecialChars)
'*******************************************************************************************
'Converts dates/Times to ISO format
'First parameter is the date/time
'Second is the type of conversion: 1=Date Only, 2=Time only, anything else does both
'Third determines if the ":" can appear in the time  
'******************************************************************************************* 

	On Error Resume Next
	
	Dim y: y=Year(dt)
	Dim m: m=Month(dt)
	Dim d: d=Day(dt)
	Dim h: h=Hour(dt)
	Dim n: n=Minute(dt)
	Dim s: s=Second(dt)
	
	if m < 10 then m="0" & m
	if d < 10 then d="0" & d
	if h < 10 then h="0" & h
	if n < 10 then n="0" & n
	if s < 10 then s="0" & s
	
	'Handle Date
	TheDate = y & "-" & m & "-" & d
	'Handle Time
	If NoSpecialChars Then
		TheTime = h & n & s
	Else
		TheTime = h & ":" & n & ":" & s
	End If
	'Combine for Date/Time
	TheDateTime = TheDate & "T" & TheTime
	
	'Return whichever value the user wanted
	If dttype = 1 Then
		iso_date = TheDate
	ElseIf dttype = 2 Then
		iso_date = TheTime
	Else
		iso_date = TheDateTime
	End If
 	
End Function
 
Function seven_Zip_Installed 
	'	Check if 7zip is installed
	seven_zip_reg = wshShell.RegRead("HKLM\SOFTWARE\7-Zip\Path") 
	If Err.number <> 0 Then
		seven_Zip_Installed = False
		Exit Function
	End If
	seven_Zip_Installed = True
End Function

Function WriteLog (ByVal Subject, ByVal Alerttype, ByVal Logfile)
	'Region Temporarily Disabled Code
	'* 	Alerttype_0 = success
	'* 	Alerttype_1 = Error
	'* 	Alerttype_2 = warning
	'* 	Alerttype_4 = information
	'EndRegion
	On Error Resume Next 
	Set objLogFile = fso.OpenTextFile(Logfile, 8, True) 
	strLF = Chr(13) 
	msgText = iso_date (Now, 0, False) & "  " 
	Select Case Alerttype
		Case 0
			msgText = msgText & "Erfolg:  "
		Case 1
			msgText = msgText & "Error:   "
		Case 2
			msgText = msgText & "Warnung: "
		Case 4
			msgText = msgText & "Info:    "			
	End Select
	msgText = msgText & Subject & VbCrLf 
	objLogFile.Write msgText 
	objLogFile.Close
End Function

Sub LogDas (ByVal Message, ByVal Alerttype, ByVal LogfileVM)
'Region Temporarily Disabled Code

	if iestatus_aktiv = true then Status.update(iso_date (Now, 0, False) & "  " & Message)
	if Alertbox = true and Alerttype = 1 then msg = MsgBox(Message, vbCritical, header & " ERROR")
	If AlertEvent = True and Alerttype <= AlertEventLevel Then wshShell.LogEvent Alerttype, Message
	If Alerttype  = 1 then Call WriteLog (Message, Alerttype, Logfile_global)
	Call WriteLog (Message, Alerttype, LogfileVM)
End Sub

 Sub SendSmtpMail(mailfrom, mailto, mailcc, mailbcc, mailsubject, mailBody, mailattachment)
	If AlertMail = True Then
		Dim	mailing
		Set mailing = CreateObject("CDO.Message")		
		mailing.From = mailfrom
		mailing.To = mailto
		mailing.CC = mailcc
		mailing.BCC = mailbcc
		mailing.Subject = mailsubject
		mailing.TextBody = mailBody 
		If	mailattachment <> "" And fso.FileExists(mailattachment) Then		
			mailing.AddAttachment (mailattachment)
		End If
		mailing.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2
		mailing.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserver") = smtp
		mailing.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = 25
		mailing.Configuration.Fields.Update
		mailing.Send
	End If
 End Sub



'EndRegion


'Region Auslesen und Prfen der bergebenen Parameter
 
Set a_args = WScript.Arguments
argscount = a_args.Count
If argscount=0 And backup_all_vms = False Then
	
	'Keine Parameter bergeben - Interaktiv ..."
	
	vmfile = InputBox(MSG_Inputbox_VMFile,header,vmfile)
	'Quit if cancel
	If vmfile = "" Then
		WScript.Quit
	End If
	'vmfolder = fso.GetParentFolderName(vmfile)
	'vmparent = fso.GetParentFolderName(vmfolder)
	'vm = Replace(Replace(vmfolder, vmparent, ""),"\","")
	'bkfile = bkpath & vm & "-" & iso_date(Now,0,True) & ".zip"
	ZIPFile = InputBox(MSG_Inputbox_Zipfile,header,bkfile)
	'Quit if cancel
	If ZIPFile = "" Then
		WScript.Quit
	End If
	'tmpfolder = fso.GetParentFolderName(zipfile) & "\" & vm
	way = "i"
ElseIf  argscount = 0 And backup_all_vms = True Then
	way = "i"
ElseIf argscount > 0 Then
	way = "a"
	Alertbox = False
	For counter = 0 To argscount-1
		
		Param = a_args(counter)
		
		Select Case UCase(Left(Param,4))
		Case "-ALL"
			backup_all_vms = True
		
		Case "-USR"
			remote_user = Right(Param,Len(Param)-5)
		
		Case "-PWD"
			remote_pass = Right(Param,Len(Param)-5)
			
		Case "-SRV"
			remote_host = Right(Param,Len(Param)-5)
	
		Case "-PRT"
			remote_port = Right(Param, Len(Param) - 5)
			
		Case "-DST"	
			bkpath = Right(Param, Len(Param) - 5)

		Case "-TMP"	
			tmpfolder = Right(Param, Len(Param) - 5)
			
		Case "-VM:"
			backup_all_vms = False
			vmfile = Right(Param, Len(Param) - 4)
			
		Case "-INT"	
			way = "i"
			Alertbox = False
		End Select
	Next



End If

'EndRegion

'Pfade herleiten und berprfen
'Region Start des Loggings
if LogPath = "" then LogPath = bkpath
if Right(LogPath,1) <> "\" then LogPath = LogPath & "\"
If fso.FolderExists(LogPath) Then
    Set objFolder = fso.GetFolder(LogPath)
	Logfile_global = LogPath & "VMWare_Backup.log"
	Call LogDas ("Backup gestartet", 0, Logfile_global)
Else
    WScript.Echo "Pfad fr Logging existiert nicht. Bitte Konfig berprfen"
End If
	
'EndRegion



'Region Initialisieren von IEStatus im iMode
iestatus_aktiv = False
If way = "i" Then
	Dim Status
	Set	Status = New iestatus
	Status.Titel = "VMWare Backup"
	Status.Create
	iestatus_aktiv = True
End If

'EndRegion

'Region Check ob alle ntigen Parameter und Vorraussetzungen vorhanden  sind und fehlende Werte ermitteln
	Precheckfailed = False

	'Vorraussetzungen fr Remotesicherung
	If backup_remote_host = True Then

		If remote_host = "" Then
				Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "",  header & ":" & MSG_ERR_remote_host_missing_short, MSG_ERR_remote_host_missing_long, "")			
				Call LogDas (MSG_ERR_remote_host_missing_short,1, Logfile_global)
				Precheckfailed = True
		End If	
		If remote_port = "" Then
				Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "",  header & ":" & MSG_ERR_remote_port_missing_short, MSG_ERR_remote_port_missing_long, "")			
				Call LogDas (MSG_ERR_remote_port_missing_short,1, Logfile_global)
				Precheckfailed = True			
		End If			
		If remote_pass = "" Then
				Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "",  header & ":" & MSG_ERR_remote_pass_missing_short, MSG_ERR_remote_pass_missing_long, "")			
				Call LogDas (MSG_ERR_remote_pass_missing_short,1, Logfile_global)
				Precheckfailed = True			
		End If	
		If remote_user = "" Then
				Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "",  header & ":" & MSG_ERR_remote_user_missing_short, MSG_ERR_remote_user_missing_long, "")			
				Call LogDas (MSG_ERR_remote_user_missing_short,1, Logfile_global)
				Precheckfailed = True			
		End If	
		
	End If
'EndRegion

IF Precheckfailed = true then WScript.Quit

'Region Komprimierung aktiv?
If compress = True Then
	If seven_zip = True Then
		'Region Kontrolle ob 7Zip installiert ist
		If seven_Zip_Installed = False Then
			Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_7Zip_not_found_short, MSG_ERR_7Zip_not_found_long, "")	
			Call LogDas (MSG_ERR_7Zip_not_found_short,1, Logfile_global)
			ErrorFlag = ErrorFlag + 1
			WScript.Quit
		End If
		'EndRegion		
	ElseIf winzip = True Then
		Body = "In der Konfiguration wurde Winzip aktiviert - dies ist aber noch nicht implementiert!"
		Subject = header & ": KonfigurationsFehler"
		Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", Subject, Body, "")	
		Call LogDas (Body,1, Logfile_global)
		ErrorFlag = ErrorFlag + 1
		WScript.Quit
	Else
		' Compress aktiv aber kein Packer gewhlt
		Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_Compress_but_no_Zip_short, MSG_ERR_Compress_but_no_Zip_long, "")	
		Call LogDas (MSG_ERR_Compress_but_no_Zip_short,1, Logfile_global)
		ErrorFlag = ErrorFlag + 1
		WScript.Quit
	End If	
End If	
'EndRegion

'Region Ist der VMWare Server erreichbar ?
If backup_remote_host = True Then
	cp.hostname = remote_host
	cp.username = remote_user
	cp.password = remote_pass
	cp.port = remote_port
End If
connected = False
For tries_srv = 1 To 10
	server.Connect cp
	If Err.number = 0 Then
      	connected = True
      	Exit For
	End If
	WScript.Sleep 10000
	Err.clear
Next
 
If Not connected Then
	Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "",  header & ":" & MSG_ERR_ServerConnect_short, MSG_ERR_ServerConnect_long, "")			
	Call LogDas (MSG_ERR_ServerConnect_short,1)
	WScript.Quit
Else	
	Call LogDas (MSG_SUC_ServerConnect,0, Logfile_global)
End If
'EndRegion

Dim o_VMs()
'Beginn der Schleife fr sicherung aller VMs		
If backup_all_vms = True Then
	Set VMs = server.RegisteredVmNames
	vmcount = VMs.count-1
	'If debugging = True then WScript.Echo vmcount
	ReDim o_VMs(vmcount)
Else 
	Dim VMs
	VMs = Array(vmfile)
	vmcount = 0
	ReDim o_VMs(0)
End If
loopcounter = 0
For Each vmfile In VMs
	doit = True
	Do Until doit = False	
		'if debugging = true then WScript.echo vmfile
		'Array mit neuem Guest-Objekt fllen
		Set  o_VMs(loopcounter) = New VM_Guest
		o_VMs(loopcounter).vmfile = vmfile
		o_VMs(loopcounter).checkpoint_begin = Now		
		
		If backup_remote_host = True Then 
			vmfile_tmp = "\\" & remote_host & "\" & Left(vmfile, 1) & "$" & Right(vmfile, Len(vmfile) - 2) 
		Else
			vmfile_tmp = vmfile
		End If
	
		If fso.FileExists(vmfile_tmp) = True Then
			Call LogDas ("VMFile " & vmfile & " gefunden", 4, Logfile_global)
		Else
			Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "",  header & ":" & MSG_ERR_VM_File_not_found_short, MSG_ERR_VM_File_not_found_long, "")			
			Call LogDas (MSG_ERR_VM_File_not_found_short, 1, Logfile_global)
			o_VMs(loopcounter).errorflag = o_VMs(loopcounter).errorflag + 1
			loopcounter = loopcounter + 1

			Exit Do
		End If
		
		o_VMs(loopcounter).vmfolder = fso.GetParentFolderName(vmfile_tmp)

		o_VMs(loopcounter).vmparent = fso.GetParentFolderName(o_VMs(loopcounter).vmfolder)
		o_VMs(loopcounter).vm = Replace(Replace(o_VMs(loopcounter).vmfolder, o_VMs(loopcounter).vmparent, ""), "\", "")
		o_VMs(loopcounter).LogfileVM = LogPath & "Backup_" & o_VMs(loopcounter).vm & "_" & iso_date(Now, 0, True) & ".log"
		o_VMs(loopcounter).ZIPFile = bkpath & o_VMs(loopcounter).vm & "-" & iso_date(Now,0,True) & ".zip"		
		If fso.FolderExists(tmpfolder) = True Then
			o_VMs(loopcounter).tmpfolder = tmpfolder & "\" & o_VMs(loopcounter).vm

			Call LogDas ("Temporrer Ordner " & o_VMs(loopcounter).tmpfolder & " aus Konfig bernommen.", 4, o_VMs(loopcounter).LogfileVM)
		Else	
			o_VMs(loopcounter).tmpfolder = fso.GetParentFolderName(o_VMs(loopcounter).zipfile) & "\" & o_VMs(loopcounter).vm
		End If
				
		Call WriteLog ("Backup von " & o_VMs(loopcounter).vm & " gestartet", 0, Logfile_global)
		Call LogDas ("Backup von " & o_VMs(loopcounter).vm & " gestartet", 4, o_VMs(loopcounter).LogfileVM)
	
		'Region Gengend Plattenplatz fr Backup?
		'Erstmal checken, ob gengend Platz auf dem Backupdrive ist
		Set VMFolderObject = fso.Getfolder (o_VMs(loopcounter).VMFolder)
		o_VMs(loopcounter).VMSize = Round(VMFolderObject.size / OneGB, 2)
		BackupDrive = fso.GetDriveName(o_VMs(loopcounter).zipfile)
		Set BackupDriveObject = fso.GetDrive(BackupDrive) 
		BackupDriveFreeSpace = Round(BackupDriveObject.availablespace / OneGB, 2)
		'Fehler und Abbruch wenn Platz nicht reicht
		If o_VMs(loopcounter).VMSize >= BackupDriveFreeSpace Then
			Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_zu_wenig_Plattenplatz_short, MSG_ERR_zu_wenig_Plattenplatz_long, "")	
			Call LogDas (MSG_ERR_zu_wenig_Plattenplatz_short,1, o_VMs(loopcounter).LogfileVM)
			o_VMs(loopcounter).errorflag = o_VMs(loopcounter).errorflag + 1
			loopcounter = loopcounter +1
			Exit Do
		End If
		
		'EndRegion

		'Connect zur VM
		o_VMs(loopcounter).connect
		
		
		If o_VMs(loopcounter).connected = False Then 
			Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "",   header & ":" & MSG_ERR_VMConnect_short, MSG_ERR_VMConnect_long, "")	
			Call LogDas (MSG_ERR_VMConnect_short,1, o_VMs(loopcounter).LogfileVM)
			o_VMs(loopcounter).errorflag = o_VMs(loopcounter).errorflag + 1			
			loopcounter = loopcounter + 1
			
			Exit Do
		Else 
			Call LogDas (MSG_SUC_VMConnect,0, o_VMs(loopcounter).LogfileVM)
			
		End If
		If o_VMs(loopcounter).connected = False Then
			Call LogDas (MSG_SUC_VMToolsConnect, 0, o_VMs(loopcounter).LogfileVM)

		End If


		'Region Ermitteln des Ausfhrungsstatus der VM um zu ermitteln ob sie nach dem Backup wieder gestartet werden muss
 
		'if debugging = true then WScript.Echo o_VMs(loopcounter).vm_status_before_backup
		If o_VMs(loopcounter).vm_status_before_backup = vmExecutionState_On Then
			Call LogDas (MSG_INF_VMStatus_Running,4, o_VMs(loopcounter).LogfileVM)
		ElseIf o_VMs(loopcounter).vm_status_before_backup = vmExecutionState_Off Then
			Call LogDas (MSG_INF_VMStatus_Off,4, o_VMs(loopcounter).LogfileVM)
		ElseIf o_VMs(loopcounter).vm_status_before_backup = vmExecutionState_Suspended Then
			Call LogDas (MSG_INF_VMStatus_Suspended,4, o_VMs(loopcounter).LogfileVM)
		Else
			Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_VMStatus_unknown_short, MSG_ERR_VMStatus_unknown_long, "")	
			Call LogDas (MSG_ERR_VMStatus_unknown_short,1, o_VMs(loopcounter).LogfileVM)
			o_VMs(loopcounter).errorflag = o_VMs(loopcounter).errorflag + 1
			loopcounter = loopcounter + 1

			Exit Do
		End If
		'EndRegion
		
		'Region Kann mit den VMWare Tools in der VM kommuniziert werden? 
		'	Check des Heartbeats - Zeit seit Start der VM in Sekunden
		'	Wenn Kommunikation mit VMWare Tools nicht geht, kann VM nicht heruntergefahren werden
		'	Eine VM ohne VMWare Tools kann nur im heruntergefahrenen Zustand gesichert werden.
		
		If o_VMs(loopcounter).vmtools_running = True Then 
			Call LogDas (MSG_SUC_VMToolsConnect,0, o_VMs(loopcounter).LogfileVM)
		End If
		If o_VMs(loopcounter).vm_status_before_backup = vmExecutionState_On = True And o_VMs(loopcounter).vmtools_running = False And use_hart_suspend_if_no_VMTools = False Then	'	VM-Tools nicht kontaktierbar - Abbruch oder Suspend nutzen
			Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_VMToolsConnect_short, MSG_ERR_VMToolsConnect_long, "")	 
			Call LogDas (MSG_ERR_VMToolsConnect_short, 1, o_VMs(loopcounter).LogfileVM)
			o_VMs(loopcounter).ErrorFlag = o_VMs(loopcounter).ErrorFlag + 1
			loopcounter = loopcounter + 1
			Exit Do
		ElseIf o_VMs(loopcounter).vm_status_before_backup = vmExecutionState_On = True And o_VMs(loopcounter).vmtools_running = False And use_hart_suspend_if_no_VMTools = True Then
			Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_VMToolsConnect_Suspend_short, MSG_ERR_VMToolsConnect_Suspend_long, "")	
			Call LogDas (MSG_ERR_VMToolsConnect_Suspend_short,2, o_VMs(loopcounter).LogfileVM)
		End If
		'EndRegion
	 	
		'Region Bei Bedarf die VM herunterfahren 
		
		'	Const vmPowerOpMode_Hard = 1
		'	Const vmPowerOpMode_Soft = 2
		'	Const vmPowerOpMode_TrySoft = 3
		If o_VMs(loopcounter).vm_status_before_backup = vmExecutionState_On Then 
			o_VMs(loopcounter).checkpoint_startshutdown = Now
			If use_suspend = False And o_VMs(loopcounter).vmtools_running = True Then 
				Call LogDas (MSG_INF_Try_Shutdown,4, o_VMs(loopcounter).LogfileVM)
				o_VMs(loopcounter).shutdown(vmPowerOpMode_Soft)
				
				If o_VMs(loopcounter).vm_status <> vmExecutionState_Off Then
					'VM ist trotz des Shutdownbefehls nicht OFF - Hngt die VM?
					If o_VMs(loopcounter).vm_status = vmExecutionState_Stuck Then
						
						Call LogDas (MSG_ERR_VM_Stuck_short,1, o_VMs(loopcounter).LogfileVM)
					End If	
					Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_VM_Hung_short, MSG_ERR_VM_Hung_long, "")	
					Call LogDas (MSG_ERR_VM_Hung_short,1, o_VMs(loopcounter).LogfileVM)
					o_VMs(loopcounter).shutdown_if_hung
					
					'Check for VM shutdown errors
					If o_VMs(loopcounter).vm_status <> vmExecutionState_Off Then
						Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_Shutdown_hard_short, MSG_ERR_Shutdown_hard_long, "")	
						Call LogDas (MSG_ERR_Shutdown_hard_short, 1, o_VMs(loopcounter).LogfileVM)
						o_VMs(loopcounter).errorflag = o_VMs(loopcounter).errorflag + 1
						loopcounter = loopcounter + 1

						Exit Do
					ElseIf o_VMs(loopcounter).vm_status = vmExecutionState_Off Then
						'Not really an error but want the user to know the shutdown was hard.
						Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_INF_Shutdown_hard_short, MSG_INF_Shutdown_hard_long, "")	
						Call LogDas (MSG_INF_Shutdown_hard_short,1, o_VMs(loopcounter).LogfileVM)	
					End If					
				
				End If
				Call LogDas (MSG_SUC_Shutdown,0, o_VMs(loopcounter).LogfileVM)
			ElseIf use_suspend = True And o_VMs(loopcounter).vmtools_running = True Then
				Call LogDas (MSG_INF_Try_Suspend,4, o_VMs(loopcounter).LogfileVM)
				o_VMs(loopcounter).suspend(vmPowerOpMode_Soft)
				
			
				If o_VMs(loopcounter).vm_status <> vmExecutionState_Suspended Then
					Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_Suspend_short, MSG_ERR_Suspend_long, "")	
					Call LogDas (MSG_ERR_Suspend_short,1, o_VMs(loopcounter).LogfileVM)
					o_VMs(loopcounter).errorflag = o_VMs(loopcounter).errorflag + 1
					loopcounter = loopcounter + 1

					Exit Do
				End If
				Call LogDas (MSG_SUC_Suspend,0, o_VMs(loopcounter).LogfileVM)
			ElseIf o_VMs(loopcounter).vmtools_running = False And use_hart_suspend_if_no_VMTools = True Then
				'VMTools laufen nicht -> Hard-Suspend
				Call LogDas (MSG_INF_Try_HartSuspend,4, o_VMs(loopcounter).LogfileVM)
				o_VMs(loopcounter).suspend(vmPowerOpMode_Hard)
				If o_VMs(loopcounter).vm_status <> vmExecutionState_Suspended Then
					Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_HartSuspend_short, MSG_ERR_HartSuspend_long, "")	
					Call LogDas (MSG_ERR_HartSuspend_short,1, o_VMs(loopcounter).LogfileVM)
					o_VMs(loopcounter).errorflag = o_VMs(loopcounter).errorflag + 1
					loopcounter = loopcounter + 1

					Exit Do
				End If
				Call LogDas (MSG_SUC_HartSuspend,4, o_VMs(loopcounter).LogfileVM)
			End If
		End If
		'EndRegion
	
		
		
		
		'Region VM Kopieren
		If o_VMs(loopcounter).vm_status_before_backup = vmExecutionState_On Or compress = False Then
			Call LogDas (MSG_INF_Start_Copy,4, o_VMs(loopcounter).LogfileVM)
			o_VMs(loopcounter).Copy
			
			Call LogDas (MSG_SUC_Copy, 0, o_VMs(loopcounter).LogfileVM)
			o_VMs(loopcounter).vm_copy = True
		ElseIf o_VMs(loopcounter).vm_status_before_backup <> vmExecutionState_On And compress = True Then
			'VM war offline - wir haben also Zeit und knnen gleich komprimieren
			o_VMs(loopcounter).checkpoint_startcopy = Now	
			Call LogDas (SMG_INF_SkipCopy,4, o_VMs(loopcounter).LogfileVM)
			o_VMs(loopcounter).tmpfolder = o_VMs(loopcounter).vmfolder
			o_VMs(loopcounter).vm_copy = False
		End If
		
		
		'EndRegion
		
		'Region Wenn VM an war nun wieder Starten
		
		If o_VMs(loopcounter).vm_status_before_backup = vmExecutionState_On Then	
			Call LogDas (MSG_INF_Try_VMStart,4, o_VMs(loopcounter).LogfileVM)
			o_VMs(loopcounter).Start
			' Wenn nun noch nicht an dann Alert
			If o_VMs(loopcounter).vm_status <> vmExecutionState_On Then
				Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_VMStart_short, MSG_ERR_VMStart_long, "")	
				Call LogDas (MSG_ERR_VMStart_short,1, o_VMs(loopcounter).LogfileVM)
				o_VMs(loopcounter).errorflag = o_VMs(loopcounter).errorflag + 1
				loopcounter = loopcounter + 1

				Exit Do
			End If
			Call LogDas (MSG_SUC_VMStart,0, o_VMs(loopcounter).LogfileVM)
		End If
		'EndRegion
		
		o_VMs(loopcounter).disconnect
		
		loopcounter = loopcounter +1
		Exit Do 
		
	Loop
	
Next



'	Aber erst noch ein Puschen - war anstrengend ...

WScript.Sleep 5 * 1000
Set server = Nothing
WScript.Sleep 5 * 1000
Set cp = Nothing




'Region VMs wieder online - Zeit zum komprimieren des Backups
loopcounter = 0	
If compress = True Then
	For Each vmfile In VMs
		doit = True
		Do Until doit = False

		
			Call WriteLog ("Komprimieren von " & o_VMs(loopcounter).vm & " wird gestartet", 0, Logfile_global)
			Call LogDas ("Komprimieren von " & o_VMs(loopcounter).vm & " wird gestartet", 4, o_VMs(loopcounter).LogfileVM)
			o_VMs(loopcounter).checkpoint_startzip = Now
			'Region Gengend Plattenplatz fr Backup?
			'Erstmal checken, ob gengend Platz auf dem Backupdrive ist

			BackupDrive = fso.GetDriveName(o_VMs(loopcounter).zipfile)
			Set BackupDriveObject = fso.GetDrive(BackupDrive) 
			BackupDriveFreeSpace = Round(BackupDriveObject.availablespace / OneGB, 2)
			'Fehler und Abbruch wenn Platz nicht reicht
			If o_VMs(loopcounter).VMSize >= BackupDriveFreeSpace Then
				Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_zu_wenig_Plattenplatz_zum_komprimieren_short, MSG_ERR_zu_wenig_Plattenplatz_zum_komprimieren_long, "")	
				Call LogDas (MSG_ERR_zu_wenig_Plattenplatz_zum_komprimieren_short,1, o_VMs(loopcounter).LogfileVM)
				o_VMs(loopcounter).errorflag = o_VMs(loopcounter).errorflag + 1
				loopcounter = loopcounter +1
				Exit Do
			End If
			
			'EndRegion		
		
			Call LogDas (MSG_INF_Start_Compress,4, o_VMs(loopcounter).LogfileVM)
		
			If seven_zip = True Then
				seven_zip_reg = wshShell.RegRead("HKLM\SOFTWARE\7-Zip\Path")
				backup_string = Chr(34) & seven_zip_reg & "\7z.exe" & Chr(34) & " a -tzip " & Chr(34) & o_VMs(loopcounter).ZIPFile & Chr(34) & " " & Chr(34) & o_VMs(loopcounter).tmpfolder & "\*" & Chr(34) & seven_zip_switch
			ElseIf winzip = True Then
				'Hier kommt noch s Aufrufbasteln fr Winzip
			End If
		
			'	Das eigentliche Komprimieren ...
			
			backup_vm = wshShell.Run(backup_string,0,True)
			If backup_vm > 0 Then
			
			'	Fehler beim Zippen
				Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_Compress_short, MSG_ERR_Compress_long, "")	
				Call LogDas (MSG_ERR_Compress_short,1, o_VMs(loopcounter).LogfileVM)
				o_VMs(loopcounter).errorflag = o_VMs(loopcounter).errorflag + 1
				loopcounter = loopcounter +1
				Exit Do
			End If
			Call LogDas (MSG_SUC_Compress,0, o_VMs(loopcounter).LogfileVM)


			If o_VMs(loopcounter).vm_status_before_backup <> vmExecutionState_Off  And o_VMs(loopcounter).tmpfolder <> o_VMs(loopcounter).vmfolder Then 
				Call LogDas (MSG_INF_Start_Delete_Tmp, 4, o_VMs(loopcounter).LogfileVM)
				deltmp = DelTreeFSO(o_VMs(loopcounter).tmpfolder)	
				If deltmp = True Then
					Call LogDas (MSG_SUC_Delete_Tmp,0, o_VMs(loopcounter).LogfileVM)
				Else
					Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", header & ":" & MSG_ERR_Delete_Tmp_short, MSG_ERR_Delete_Tmp_long, "")
					Call LogDas (MSG_ERR_Delete_Tmp_short,1, o_VMs(loopcounter).LogfileVM)
					ErrorFlag = ErrorFlag + 1
				End If	
			Else
				Call LogDas (MSG_skip_Delete_Tmp,0, o_VMs(loopcounter).LogfileVM)
			End If

			
			
			'Region Alte Backups lschen
			If CleanUpBackupFiles = True And compress = True Then
				Call LogDas (MSG_INF_Delete_Backups,4, o_VMs(loopcounter).LogfileVM)
				Call Delete_Old_Backup_Files (vm, fso.GetParentFolderName(o_VMs(loopcounter).zipfile))
				Call LogDas (MSG_SUC_Delete_Backups,0, o_VMs(loopcounter).LogfileVM)
			End If
		
			'EndRegion
			
			'Region Schlussnachricht
			' Filestatistiken	
			
			Set zf = fso.getfile(o_VMs(loopcounter).zipfile)
			o_VMs(loopcounter).ZipFileSize = Round(zf.size / OneGB, 2)
			
			'	Wie lang hats denn gedauert?...
			If o_VMs(loopcounter).vm_status_before_backup = vmExecutionState_On Then
				o_VMs(loopcounter).time_shutdown = DateDiff("n", o_VMs(loopcounter).checkpoint_begin, o_VMs(loopcounter).checkpoint_startcopy)
				o_VMs(loopcounter).time_startup = DateDiff("n", o_VMs(loopcounter).checkpoint_startvm, o_VMs(loopcounter).checkpoint_started)
			End If
			
			o_VMs(loopcounter).time_off = DateDiff("n",o_VMs(loopcounter).checkpoint_startshutdown,o_VMs(loopcounter).checkpoint_started)
			o_VMs(loopcounter).time_sum = DateDiff("n",o_VMs(loopcounter).checkpoint_begin,Now)	
			o_VMs(loopcounter).time_copy = DateDiff("n",o_VMs(loopcounter).checkpoint_startcopy,o_VMs(loopcounter).checkpoint_startvm)
			
			If o_VMs(loopcounter).VM_Copy = True Then
				success_message = success_message & VbCrLf & MSG_Success_Copytime & o_VMs(loopcounter).time_copy & MSG_Minuten	 & "."
			End If
			If o_VMs(loopcounter).vm_status_before_backup = vmExecutionState_On Then
				success_message = success_message & VbCrLf & MSG_Success_VMShutdownTime & o_VMs(loopcounter).time_shutdown & MSG_Minuten & "."
				success_message = success_message & VbCrLf & MSG_Success_VMStartTime & o_VMs(loopcounter).time_startup & MSG_Minuten & "."
				success_message = success_message & VbCrLf & MSG_Success_VMOfflineTime & o_VMs(loopcounter).time_off & MSG_Minuten & "."
			End If
			success_message = success_message & VbCrLf
			If compress = True Then
				success_message = success_message & VbCrLf & MSG_Success_ZipSize & o_VMs(loopcounter).ZipFileSize & MSG_Gigabyte & "."
			End If
			success_message = success_message & VbCrLf & MSG_Success_FreeSpace & BackupDriveFreeSpace & MSG_Gigabyte & "."
			success_message = success_message & VbCrLf & MSG_Success_VMSize & o_VMs(loopcounter).VMSize & MSG_Gigabyte & "."
			success_message = success_message & VbCrLf & VbCrLf & MSG_Success_GesamtTime & o_VMs(loopcounter).time_sum & MSG_Minuten & "."
			success_message = success_message & VbCrLf & MSG_Success_StartTime & iso_date(o_VMs(loopcounter).checkpoint_begin,0,False)
			success_message = success_message & VbCrLf & MSG_Success_EndTime & iso_date(Now,0,False)
			Subject = header & ": " & MSG_Backup_Success
			
			If o_VMs(loopcounter).errorflag = 0 And WarningFlag = 0 Then
				Call LogDas (MSG_Backup_Success, 0, o_VMs(loopcounter).LogfileVM)
				Call WriteLog (o_VMs(loopcounter).vm & " " & MSG_Backup_Success, 0, Logfile_global)
				if Alertbox = true then msg = MsgBox(success_message, 0, Subject)
			ElseIf o_VMs(loopcounter).errorflag > 0 Then 
				Call LogDas (MSG_Backup_Error, 1, o_VMs(loopcounter).LogfileVM)
				if Alertbox = true then msg = MsgBox(success_message, vbCritical, Subject)
			ElseIf WarningFlag > 0 Then
				Call LogDas (MSG_Backup_Warning, , o_VMs(loopcounter).LogfileVM2)
					Call WriteLog (o_VMs(loopcounter).vm & " " & MSG_Backup_Warning, 2, Logfile_global)
					if Alertbox = true then msg = MsgBox(success_message, 4, Subject)
			End If
						
			Call LogDas (success_message,4, o_VMs(loopcounter).LogfileVM)
			Call SendSmtpMail (mailfrom, adminmail, adminmailcc, "", Subject, success_message, o_VMs(loopcounter).LogfileVM)				
			globalerrorflag = globalerrorflag + o_VMs(loopcounter).errorflag
			globalWarningFlag = globalWarningFlag + o_VMs(loopcounter).warningflag
			loopcounter = loopcounter +1	
			Exit Do
		Loop 
		
	Next
End If	
		'EndRegion

msg = MsgBox("Fertig", 4, Subject)


If globalerrorflag = 0 And globalWarningFlag = 0 Then
	Call WriteLog (MSG_Backup_Success, 0, Logfile_global)
	if Alertbox = true then msg = MsgBox(success_message, 0, Subject)
ElseIf globalerrorflag > 0 Then 
	Call WriteLog (MSG_Backup_Error, 0, Logfile_global)

	if Alertbox = true then msg = MsgBox(success_message, vbCritical, Subject)
ElseIf globalWarningFlag > 0 Then
		Call WriteLog (MSG_Backup_Warning, 2, Logfile_global)
		if Alertbox = true then msg = MsgBox(success_message, 4, Subject)
End If

globalerrorflag

If iestatus_aktiv = True Then
	Status.delete
	Set Status = Nothing
End If

WScript.Quit


